/**
 * @file FootyDocSelect.cpp
 * @brief CFootyDocNX̒őI֘Ȁs܂B
 * @author Shinji Watanabe
 * @version Jan.22.2008
 */

#include "FootyDoc.h"

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::SetSelectStart
 * @brief IJnʒuݒ肵܂B
 * @param pStart ݒ肷ʒu
 */
bool CFootyDoc::SetSelectStart(CEditPosition *pStart)
{
	if (!pStart)return false;
	m_nSelectType = SELECT_NONE;
	m_cSelectBegin = *pStart;
	return true;
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::SetSelectStart
 * @brief IJnʒuݒ肵܂B
 * @param pStart ݒ肷ʒu
 */
bool CFootyDoc::SetSelectStart(CUndoBuffer::CPosInfo *pStart)
{
	if (!pStart)return false;
	m_nSelectType = SELECT_NONE;
	pStart->SetPosition(&m_cSelectBegin,&m_lsLines);
	return true;
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::SetSelectEndNormal
 * @brief IIʒuݒ肷
 * @param ݒ肷ʒu
 */
bool CFootyDoc::SetSelectEndNormal(CEditPosition *pEnd){
	if (!pEnd)return false;
	m_cSelectEnd = *pEnd;
	if (m_cSelectEnd == m_cSelectBegin)		// JnʒuƓ
		m_nSelectType = SELECT_NONE;
	else if (m_cSelectEnd > m_cSelectBegin)	// ʏI
		m_nSelectType = SELECT_NORMAL;
	else									// tʒuI
		m_nSelectType = SELECT_REV;
	return true;
}

//-----------------------------------------------------------------------------
/**
 * CFootyDoc::SetSelectEndNormal
 * @brief IIʒuݒ肷
 */
bool CFootyDoc::SetSelectEndNormal(CUndoBuffer::CPosInfo *pEnd)
{
	if (!pEnd)return false;
	pEnd->SetPosition(&m_cSelectEnd,&m_lsLines);
	if (m_cSelectEnd == m_cSelectBegin)		// JnʒuƓ
		m_nSelectType = SELECT_NONE;
	else if (m_cSelectEnd > m_cSelectBegin)	// ʏI
		m_nSelectType = SELECT_NORMAL;
	else									// tʒuI
		m_nSelectType = SELECT_REV;
	return true;
}

/*-------------------------------------------------------------------
CFootyDoc::GetSelStart
IJnʒu擾郋[`
-------------------------------------------------------------------*/
CEditPosition *CFootyDoc::GetSelStart(){
	if (m_nSelectType == SELECT_REV ||
		m_nSelectType == SELECT_BOX_REV)
		return &m_cSelectEnd;
	else
		return &m_cSelectBegin;
}

/*-------------------------------------------------------------------
CFootyDoc::GetSelEnd
IIʒu擾郋[`
-------------------------------------------------------------------*/
CEditPosition *CFootyDoc::GetSelEnd(){
	if (m_nSelectType == SELECT_REV ||
		m_nSelectType == SELECT_BOX_REV)
		return &m_cSelectBegin;
	else
		return &m_cSelectEnd;
}

/*-------------------------------------------------------------------
CFootyDoc::SelectAll
SđI
-------------------------------------------------------------------*/
void CFootyDoc::SelectAll(){
	m_nSelectType = SELECT_NORMAL;
	m_cSelectBegin.SetPosition(GetTopLine(),0);
	LinePt pLastLine = GetEndLine();pLastLine--;
	m_cSelectEnd.SetPosition(pLastLine,pLastLine->GetLineLength());
	m_cCaretPos = m_cSelectEnd;
}

/**
 * CFootyDoc::GetSelText
 * @brief IĂeLXg擾郋[`
 * @param pString o͐
 * @param nLineMode 
 */
bool CFootyDoc::GetSelText(std::wstring *pString, LineMode nLineMode){
	if (!pString || !IsSelecting())return false;
	// 錾
	size_t nNowIndex = 0;						//!< pÃ݂CfbNXԍ
	size_t nReserve = GetSelLength(nLineMode);	//!< mۗ
	CEditPosition *pSelStart = GetSelStart();	//!< IJnʒu
	CEditPosition *pSelEnd = GetSelEnd();		//!< IIʒu
	CEditPosition cNowPos;						//!< ݂̈ʒu
	bool bCopyLine;

	// ܂Ƃ߂Ċmۂ
	pString->clear();
	pString->resize(nReserve);
	
	// sR[hݒ
	if (nLineMode == LM_AUTOMATIC)
		nLineMode = (LineMode)GetLineMode();
	
	/*񂵂Ȃf[^Ă*/
	cNowPos = *pSelStart;
	forever
	{
		bCopyLine = false;
		if (pSelStart->GetLineNum() == cNowPos.GetLineNum() &&
			pSelEnd->GetLineNum() == cNowPos.GetLineNum())
		{
			pString->insert(nNowIndex,
				&cNowPos.GetLinePointer()->m_strLineData[pSelStart->GetPosition()],
				pSelEnd->GetPosition() - pSelStart->GetPosition());
			break;
		}
		else if (pSelStart->GetLineNum() == cNowPos.GetLineNum())
		{
			pString->insert(nNowIndex,
				&pSelStart->GetLinePointer()->m_strLineData[pSelStart->GetPosition()]);
			nNowIndex += cNowPos.GetLinePointer()->GetLineLength() - pSelStart->GetPosition();
			bCopyLine = true;
		}
		else if (pSelEnd->GetLineNum() == cNowPos.GetLineNum())
		{
			pString->insert(nNowIndex,
				cNowPos.GetLinePointer()->m_strLineData.c_str(),pSelEnd->GetPosition());
			break;
		}
		else
		{
			pString->insert(nNowIndex,cNowPos.GetLinePointer()->m_strLineData);
			nNowIndex += cNowPos.GetLinePointer()->GetLineLength();
			bCopyLine = true;
		}

		// sR[h̃Rs[
		if (bCopyLine)
		{
			switch((int)nLineMode)
			{
			case LM_CRLF:
				pString->insert(nNowIndex,L"\r\n");
				nNowIndex += 2;
				break;
			case LM_CR:
				pString->insert(nNowIndex,L"\r");
				nNowIndex += 1;
				break;
			case LM_LF:
				pString->insert(nNowIndex,L"\n");
				nNowIndex += 1;
				break;
			}
		}

		/*̍s*/
		cNowPos.MoveRealNext(&m_lsLines,1);
	}
	return true;
}

/**
 * CFootyDoc::DeleteSelected
 * @brief IĂeLXg폜܂B
 * @param pUndoBuffer AhDɋL^邽߂̃obt@BNULLB
 * @note 폜͑IԂăLbgʒu(pPos)In_Ɉړ܂B
 */
CFootyDoc::RedrawType CFootyDoc::DeleteSelected(CUndoBuffer *pUndoBuffer)
{
	if (!IsSelecting())return REDRAW_FAILED;

	// 錾
	CEditPosition *pSelStart = GetSelStart();	//!< IJnʒu
	CEditPosition *pSelEnd = GetSelEnd();		//!< IIʒu
	LinePt pStartLine = pSelStart->GetLinePointer();
	LinePt pEndLine = pSelEnd->GetLinePointer();
	LinePt pStartLineBack = pStartLine;

	// 
	m_cCaretPos = *pSelStart;
	if (pUndoBuffer)
	{
		pUndoBuffer->m_nUndoType = CUndoBuffer::UNDOTYPE_DELETE;
		pUndoBuffer->m_cBeforeStart = *pSelStart;
		pUndoBuffer->m_cBeforeEnd = *pSelEnd;
		GetSelText(&pUndoBuffer->m_strBefore);
	}

	// 
	if (pSelStart->GetLineNum() == pSelEnd->GetLineNum())
	{
		pStartLine->m_strLineData.erase(
			pSelStart->GetPosition(),pSelEnd->GetPosition()-pSelStart->GetPosition());
		SetLineInfo(pStartLine);
	}
	else
	{
		// JnsƏIs̑Iʒu폜
		pStartLine->m_strLineData.erase(pSelStart->GetPosition());
		pStartLine->m_strLineData.insert(pSelStart->GetPosition(),
			&pEndLine->m_strLineData[pSelEnd->GetPosition()]);

		// ̊Ԃ̍s폜
		pStartLine++;
		pEndLine++;
		DeleteLine(pStartLine,pEndLine);

		// f[^tbV
		SetLineInfo(pStartLineBack,pEndLine);
	}

	// I
	m_nSelectType = SELECT_NONE;
	SendMoveCaretCallBack();
	return REDRAW_ALL;
}

/**
 * CFootyDoc::ClearSelected by inovia
 * @brief IĂeLXg܂B
 * @param pUndoBuffer AhDɋL^邽߂̃obt@BNULLB
 * @note 폜͑IԂăLbgʒu(pPos)In_Ɉړ܂B
 */
int CFootyDoc::ClearSelected()
{
	if (!IsSelecting())return REDRAW_FAILED;
	// I
	m_nSelectType = SELECT_NONE;
	SendMoveCaretCallBack();
	return REDRAW_ALL;
}

/*-------------------------------------------------------------------
CFootyDoc::GetSelLength
ݑIĂeLXg̒擾܂
-------------------------------------------------------------------*/
size_t CFootyDoc::GetSelLength(LineMode nLineMode){
	if (!IsSelecting())return 0;
	
	/*錾*/
	size_t nSelSize = 0;						/*IĂ傫*/
	size_t nLineCodeSize;
	CEditPosition cNowPos;						/*ݑ̍s*/
	CEditPosition *pSelStart = GetSelStart();	/*IJnʒu*/
	CEditPosition *pSelEnd = GetSelEnd();		/*IIʒu*/
	
	/*CR[h̒擾*/
	if (nLineMode == LM_AUTOMATIC)
		nLineMode = m_nLineMode;

	switch(static_cast<size_t>(nLineMode)){
	case LM_CRLF:
		nLineCodeSize = 2; break;
	case LM_CR: case LM_LF:
		nLineCodeSize = 1; break;
	}
	
	/*[vČvZ*/
	cNowPos = *pSelStart;
	forever{
		/*Ƃ肠̍s̒ǉ*/
		nSelSize += cNowPos.GetLinePointer()->GetLineLength();
		/*ŏ̑IŝƂ́A܂ł*/
		if (pSelStart->GetLineNum() == cNowPos.GetLineNum())
			nSelSize -= pSelStart->GetPosition();
		/*ŏȊIŝƂ́A̕ă[v𔲂*/
		if (pSelEnd->GetLineNum() == cNowPos.GetLineNum()){
			nSelSize -= cNowPos.GetLinePointer()->GetLineLength() - pSelEnd->GetPosition();
			break;
		}
		/*ŏIsłȂƂ́AsvX*/
		nSelSize += nLineCodeSize;
		cNowPos.MoveRealNext(&m_lsLines,1);
	}
	
	/*lԋp*/
	return nSelSize;
}

/*-------------------------------------------------------------------
CFootyDoc::SelectWord
݂̃Lbg̈ʒuŒPIs܂B
-------------------------------------------------------------------*/
void CFootyDoc::SelectWord(){
	/*݂̈ʒuɂP擾܂*/
	LinePt pLine = m_cCaretPos.GetLinePointer();
	CFootyLine::WordInfo wInfo = pLine->GetWordInfo(m_cCaretPos.GetPosition());
	/*P̑Is܂B*/
	m_cCaretPos.SetPosition(pLine,wInfo.m_nBeginPos);
	SetSelectStart();
	m_cCaretPos.SetPosition(pLine,wInfo.m_nEndPos);
	SetSelectEndNormal();
	SendMoveCaretCallBack();
}

/*[EOF]*/
